<template>
  <span :id="id" :name="field.name+'_show'" class="component-input-span">
    <template
      v-if="field.displayType == Constant.PermissionType_HIDDEN || field.textType.toLowerCase() == 'hidden'"
    >
      <!-- 隐藏 TODO:注意，隐藏时不应该有hidden的field存在，有安全问题，以后要改过来：Jarod -->
      <input type="hidden" v-model="field.value" />
      <div class="radio-vertical" v-if="field.mobile&&field.hiddenValue">
        <div class="titleName">
          {{field.discript?field.discript:field.name}}
        </div>
        <div class="view-li">
          <div class="view-li-right">
            {{field.hiddenValue}}
          </div>
        </div>
      </div>
    </template>
    
    <!--只读-->
    <template v-else-if="field.textType.toLowerCase() == 'readonly' || field.displayType == Constant.PermissionType_READONLY || field.displayType == Constant.PermissionType_DISABLED">
      <template v-if="field.readOnlyShowValOnly">
        <!-- 只读（文本模式） -->
        <div class="radio-horizontal" v-if="field.mobile && field.layout == 'horizontal'">
          <div class="titleName" v-if="field.showFieldTitle">
            {{field.discript?field.discript:field.name}}
            <span style="color:red" v-if="field.essential || field.instantValidate || (field.validateLibs && field.validateLibs.indexOf('checkEmpty_system') > 0)">*</span>
          </div>
          <div>
            <a class="mint-cell"> 
              <div class="mint-cell-left"></div> 
              <div class="mint-cell-wrapper">
                <div class="mint-cell-title">
                   <span class="mint-radio-label">{{field.value}}</span>
                </div>
              </div> 
            </a>
          </div>
        </div>
      </template>
      <template v-else>
        <!-- 只读（控件模式） -->
        <!--水平-->
        <div class="radio-horizontal" v-if="field.mobile && field.layout == 'horizontal'">
          <div class="titleName" v-if="field.showFieldTitle">
            {{field.discript?field.discript:field.name}}
            <span style="color:red" v-if="field.essential || field.instantValidate || (field.validateLibs && field.validateLibs.indexOf('checkEmpty_system') > 0)">*</span>
          </div>
          <div>
            <mt-radio
              title=""
              @change="onChange"
              v-model="field.value"
              :options="field.options">
            </mt-radio>
          </div>
        </div>
        <div class="radio-vertical" v-if="field.mobile && field.layout == 'vertical'"> 
          <div class="titleName" v-if="field.showFieldTitle">
            {{field.discript?field.discript:field.name}}
            <span style="color:red" v-if="field.essential || field.instantValidate || (field.validateLibs && field.validateLibs.indexOf('checkEmpty_system') > 0)">*</span>  
          </div>
          <div>
            <mt-radio
              title=""
              @change="onChange"
              v-model="field.value"
              :options="field.options">
            </mt-radio>
          </div>
        </div>
      </template>
    </template>

    <template v-else-if="field.displayType == Constant.PermissionType_MODIFY">
      <!-- 可编辑 -->
      <!--水平-->
      <div class="radio-horizontal" v-if="field.mobile && field.layout == 'horizontal'">
        <div class="titleName" v-if="field.showFieldTitle">
          {{field.discript?field.discript:field.name}}
          <span style="color:red" v-if="field.essential || field.instantValidate || (field.validateLibs && field.validateLibs.indexOf('checkEmpty_system') > 0)">*</span>
        </div>
        <div :class="{instantVerification: isActive}">
          <div class="radio-box">
            <mt-radio
              title=""
              @change="onChange"
              v-model="field.value"
              :options="field.options">
            </mt-radio>
          </div>
          <div class="tips" v-show="isActive">
            {{errorMessage}}
          </div>
        </div>
      </div>
      <!--垂直-->
      <div class="radio-vertical" v-if="field.mobile && field.layout == 'vertical'">
        <div class="titleName" v-if="field.showFieldTitle">
          {{field.discript?field.discript:field.name}}
          <span style="color:red" v-if="field.essential || field.instantValidate || (field.validateLibs && field.validateLibs.indexOf('checkEmpty_system') > 0)">*</span>
        </div>
        <div :class="{instantVerification: isActive}">
          <div class="radio-box">
            <mt-radio
              title=""
              @change="onChange"
              v-model="field.value"
              :options="field.options">
            </mt-radio>
          </div>
          <div class="tips" v-show="isActive">
            {{errorMessage}}
          </div>
        </div>
      </div>
    </template>
  </span>
</template>

<script>
import Constant from "@/Constant.js"
// import getTheParent from '@/assets/js/getTheParentComponent';
import controlHidden from "@/assets/js/controlHidden.js"
export default {
  name: "o-radio",
  props: ["id"],
  computed: {
    field: function() {
      let allData = this.$parent.findField(this.id);
      if(allData.discript) {//识别控件描述最后一个字符为*时，*变红
        if(allData.discript.charAt(allData.discript.length - 1) == "*") {
          allData.discript = allData.discript.replace(/(\s|\*)+$/g, '');
          allData.essential = true;
        }
      }
      if(allData.textType == 'readonly' || allData.displayType == 1 || allData.displayType == 4) {
        for(let i=0; i<allData.options.length; i++) {
          allData.options[i].disabled = true;
        }
      }
      allData.options = JSON.parse(JSON.stringify(allData.options).replace(/option/g,"label"));
      if(!allData.value) {
        if(allData.options && allData.options.length > 0) {
          for(let i=0; i<allData.options.length; i++) {
            if(allData.options[i].def) {
              allData.value = allData.options[i].value;
            }
          }
        }
      }
      if(allData.options && allData.options.length > 0) {
        for(let i=0; i<allData.options.length; i++) {
          if(!allData.options[i].label) {
            allData.options[i].label = ' ';
          }
        }
      }
      return allData;
    }
  },
  mounted(){
    this.$nextTick(()=>{
      let field = this.field;
      if(field.isHideType) {
        let id = this.id,
          formShowType = field.formShowType;
        controlHidden({id, field, formShowType})
      }
    })
  },
  methods: {
    onChange() {
      if(this.field.instantValidate) {
        this.isFieldClear = false;
        let value = true;
        let formData = this.$parent.checkData(value);
        //item[this.field.name] = this.field.value;
        this.$api.formValidation(
          this.$root.appid, 
          formData,
          {
            onSucess: response => {
              if(response.data.errcode == 4001) {
                if(response.data.errors && response.data.errors.length > 0) {
                  let arr = response.data.errors;
                  for(let i=0; i<arr.length; i++) {
                    if(this.field.name == arr[i].field) {
                      this.isActive = true;
                      this.errorMessage = arr[i].errmsg
                      return;
                    }else {
                      this.isActive = false;
                      this.errorMessage = '';
                    }
                  }
                }
              }else if(response.data.errcode == 0) {
                this.isActive = false;
              }
            }
          }
        )
      } 
   
      if (this.field.refreshOnChanged){//判断是否需要刷新
        let havePar = false;
        let par  = '';
        while(!havePar) {
          par = par + '.$parent';
          let url = 'this' + par + '.refresh';
          if(eval(url)) {
            let path = url + '(' + "'"+ this.id +"'" + ')';
            eval(path);
            break
          }
        }
        // this.$parent.refresh(this.id);
        // this.$parent.$parent.$parent.$parent.$parent.$parent.$parent.$parent.refresh(this.id);
      }
    },
  },
  data: function() {
    return { 
      Constant, 
      selectedOption: {},
      vertical:'input-vertical',
      value:'',
      isActive:false,
      errorMessage:'',
    };
  }
};
</script>